<template>
  <q-card
    flat
    class="q-mt-lg rounded-borders-10"
    :class="{
      'q-pa-sm': screenWidth >= 768 && screenWidth <= 899,
      'q-pa-lg': screenWidth >= 900,
    }"
  >
    <q-card-section>
      <div class="row">
        <div class="col-4 q-my-auto">
          <label class="title-headline"> Trainings & Certificates </label>
        </div>

        <q-spacer />

        <div class="col" align="right">
          <q-btn
            unelevated
            no-caps
            text
            label="Add"
            icon="add"
            class="btn-md text-primary"
            @click="showAddTraining(), (showAddDialog = true)"
          />
        </div>
      </div>
    </q-card-section>

    <q-card-section>
      <div
        class="row q-mb-md"
        v-for="(training, k) in trainingStore.trainings"
        :key="k"
      >
        <div class="col q-mr-xl">
          <div
            class="row"
            :class="{
              column: screenWidth <= 899,
            }"
          >
            <div class="col">
              <p
                class="text-caption text-weight-bold text-grey-6 q-mt-xs"
                style="font-size: 11px"
              >
                TRAINING NAME
              </p>
            </div>

            <div class="col">
              <p
                class="q-mt-xs"
                style="overflow: hidden; word-break: break-all"
              >
                {{ training.training_name }}
              </p>
            </div>
          </div>
        </div>

        <div class="col">
          <div
            class="row"
            :class="{
              column: screenWidth <= 899,
            }"
          >
            <div class="col">
              <p
                class="text-caption text-weight-bold text-grey-6 q-mt-xs"
                style="font-size: 11px"
              >
                UPLOAD CERTIFICATE
              </p>
            </div>

            <div class="col">
              <a :href="training.certificate_url" target="_blank">
                <p style="overflow: hidden; text-overflow: ellipsis">
                  {{ training.certificate_url }}
                </p>
              </a>
            </div>
          </div>
        </div>

        <div class="col" align="right">
          <q-btn
            unelevated
            size="md"
            icon="eva-edit-outline"
            class="btn-edit q-mr-xs text-grey-6"
            @click="showEditTraining(training.id), (showEditDialog = true)"
          />

          <q-btn
            unelevated
            size="md"
            icon="eva-trash-outline"
            class="btn-edit text-grey-6"
            @click="showDeleteTraining(training.id), (showDeleteDialog = true)"
          />
        </div>
      </div>
    </q-card-section>
  </q-card>

  <!-- DIALOG: ADD TRAINING & CERTIFICATES  -->
  <q-dialog v-model="showAddDialog" persistent @hide="showAddDialog === false">
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 1300px; max-width: 90vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10"
          >Add Training & Certificates</span
        >
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <q-form @submit="addDetails(form2)">
          <div id="form-details">
            <q-card
              v-for="(training, k) in form2.trainings"
              :key="k"
              flat
              bordered
              class="q-pa-lg rounded-borders-10 q-mb-md"
            >
              <div
                v-if="form2.trainings.length > 1"
                class="text-right text-negative"
              >
                <q-btn
                  unelevated
                  no-caps
                  text
                  label="Remove Training"
                  icon="remove"
                  class="btn-md"
                  @click="removeRowCertificate(k)"
                />
              </div>

              <div class="row">
                <div class="col q-mr-lg">
                  <div class="q-py-xs">
                    <label class="text-caption text-weight-bold text-grey-6"
                      >TRAINING NAME</label
                    >
                    <q-input
                      v-model="training.training_name"
                      dense
                      outlined
                      class="q-mt-sm"
                    />
                  </div>
                </div>

                <div class="col">
                  <div class="q-py-xs">
                    <label class="text-caption text-weight-bold text-grey-6"
                      >UPLOAD CERTIFICATE</label
                    >
                    <q-file
                      dense
                      outlined
                      v-model="training.certificate"
                      class="q-mt-sm"
                      max-file-size="5242880"
                      :filter="checkFileType"
                      @rejected="onRejected(training.certificate)"
                      @update:model-value="onRejected(training.certificate)"
                    >
                      <template v-slot:prepend>
                        <q-icon name="eva-attach-outline" />
                      </template>
                    </q-file>
                    <p
                      id="error"
                      class="q-field_messages text-negative q-pa-sm"
                    >
                      {{ errorMessage }}
                    </p>
                  </div>
                </div>
              </div>
            </q-card>

            <div class="text-right text-primary q-mt-md">
              <q-btn
                unelevated
                no-caps
                text
                label="Add Training"
                icon="add"
                class="btn-md"
                @click="addRowCertificate()"
              />
            </div>
          </div>

          <div class="q-mt-xl flex justify-center">
            <q-btn
              unelevated
              class="btn-lg btn--shade-1 text-white"
              type="submit"
              label="SUBMIT"
              :loading="loading"
            />
          </div>
        </q-form>
      </q-card-section>
    </q-card>
  </q-dialog>

  <!-- DIALOG: EDIT TRAINING & CERTIFICATES  -->
  <q-dialog
    v-model="showEditDialog"
    persistent
    @hide="showEditDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 1300px; max-width: 90vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10"
          >Edit Training & Certificate</span
        >
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <q-form @submit="editDetails(form.id)">
          <div id="form-details">
            <div class="row">
              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-6"
                    >TRAINING NAME</label
                  >
                  <q-input
                    v-model="form.training_name"
                    dense
                    outlined
                    class="q-mt-sm"
                  />
                </div>
              </div>

              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-6"
                    >UPLOAD CERTIFICATE</label
                  >
                  <q-file
                    dense
                    outlined
                    v-model="form.certificate"
                    class="q-mt-sm"
                    max-file-size="5242880"
                    :filter="checkFileType"
                    :label="
                      form.certificate === null
                        ? form.certificate_name
                        : 'Selected File'
                    "
                    @rejected="onRejected(form.certificate)"
                    @update:model-value="onRejected(form.certificate)"
                    @click="toggleFileNameVisibility"
                    @change="onFileChange"
                  >
                    <template v-slot:prepend>
                      <q-icon name="eva-attach-outline" />
                    </template>
                  </q-file>
                  <p id="error" class="q-field_messages text-negative q-pa-sm">
                    {{ errorMessage }}
                  </p>
                </div>
              </div>
            </div>
          </div>

          <div class="q-mt-xl flex justify-center">
            <q-btn
              unelevated
              class="btn-lg btn--shade-1 text-white q-mr-lg"
              type="submit"
              label="SUBMIT"
              :loading="loading"
            />
          </div>
        </q-form>
      </q-card-section>
    </q-card>
  </q-dialog>

  <!-- DIALOG: DELETE TRAINING & CERTIFICATES  -->
  <q-dialog
    v-model="showDeleteDialog"
    persistent
    @hide="showDeleteDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 600px; max-width: 80vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10"
          >Delete Training & Certificate</span
        >
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section class="q-pt-none">
        Are you sure you want to delete this entry?
      </q-card-section>

      <q-card-section>
        <div class="q-mt-xl flex justify-center">
          <q-btn
            unelevated
            class="btn-lg bg-negative text-white"
            :loading="deleteLoading"
            label="DELETE"
            @click="deleteDetails(form.id)"
          />
        </div>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>

<script>
import { defineComponent, ref, reactive, onMounted, onUnmounted } from "vue";
import { useTraining } from "../../store/training";
import { requiredField } from "src/hooks/validations";
import useJobseekerHook from "../../hooks/jobseekerHook";

export default defineComponent({
  setup() {
    const trainingStore = useTraining();
    const { getTrainings, showTraining } = trainingStore;

    const {
      loading,
      deleteLoading,
      doCreateTraining,
      doUpdateTraining,
      doDeleteTraining,
    } = useJobseekerHook();
    const showAddDialog = ref(false);
    const showEditDialog = ref(false);
    const showDeleteDialog = ref(false);
    const isError = ref(false);
    const errorMessage = ref("");
    const screenWidth = ref(0);

    const form = reactive({
      id: null,
      training_name: null,
      certificate: null,
      certificate_name: null,
      _method: "PUT",
    });

    const form2 = reactive({
      trainings: [
        {
          training_name: null,
          certificate: null,
        },
      ],
    });

    const fetchUserDetails = () => {
      getTrainings();
    };

    const addRowCertificate = () => {
      form2.trainings.push({
        training_name: null,
        certificate: null,
      });
    };

    const removeRowCertificate = (index) => {
      form2.trainings.splice(index, 1);
    };

    const showAddTraining = () => {
      form2.trainings = [
        {
          training_name: null,
          certificate: null,
        },
      ];
    };
    const addDetails = async () => {
      const formData = new FormData();

      for (let i = 0; i < form2.trainings.length; i++) {
        formData.append(
          `trainings[${i}][training_name]`,
          form2.trainings[i].training_name
        );
        formData.append(
          `trainings[${i}][certificate]`,
          form2.trainings[i].certificate
        );
      }

      await doCreateTraining(formData);

      showAddDialog.value = false;
      fetchUserDetails();
    };

    const showEditTraining = (id) => {
      showTraining(id);

      form.id = trainingStore.training.id;
      form.training_name = trainingStore.training.training_name;
      form.certificate_name = trainingStore.training.certificate;
    };

    const editDetails = async (id) => {
      if (form.certificate === null) {
        await doUpdateTraining(id, form);
      } else {
        const formData = new FormData();

        formData.append("training_name", form.training_name);
        formData.append("certificate", form.certificate);
        formData.append("_method", form._method);

        await doUpdateTraining(id, formData);
      }

      showEditDialog.value = false;
      fetchUserDetails();
    };

    const showDeleteTraining = (id) => {
      form.id = id;
      showDeleteDialog.value = true;
    };

    const deleteDetails = async (id) => {
      await doDeleteTraining(id);

      showDeleteDialog.value = false;
      fetchUserDetails();
    };

    onMounted(() => {
      window.addEventListener("resize", screenResize);
    });

    onUnmounted(() => {
      window.removeEventListener("resize", screenResize);
    });

    const screenResize = () => {
      screenWidth.value = window.innerWidth;
    };

    fetchUserDetails();
    screenResize();

    return {
      trainingStore,
      form,
      form2,
      showAddDialog,
      showEditDialog,
      showDeleteDialog,
      loading,
      deleteLoading,
      validations: {
        requiredField,
      },
      checkFileType(files) {
        return files.filter(
          (file) =>
            file.type === "application/msword" ||
            file.type ===
              "application/vnd.openxmlformats-officedocument.wordprocessingml.document" ||
            file.type === "application/pdf" ||
            file.type === "image/png" ||
            file.type === "image/jpeg" ||
            file.type === "image/jpg"
        );
      },
      onRejected(files) {
        for (let x = 0; x < files.length; x++) {
          const file = files[x];

          if (file.failedPropValidation === "max-file-size") {
            isError.value = true;
            errorMessage.value = "File size should not be greater than 5MB";
          } else if (file.failedPropValidation === "filter") {
            isError.value = true;
            errorMessage.value = "The file type uploaded is not supported";
          } else {
            isError.value = false;
            errorMessage.value = "";
          }
        }
      },
      showAddTraining,
      showEditTraining,
      showDeleteTraining,
      addDetails,
      editDetails,
      deleteDetails,
      addRowCertificate,
      removeRowCertificate,
      screenResize,
      screenWidth,
    };
  },
});
</script>

<style lang="scss" scoped>
.btn-edit {
  border-radius: 50px !important;
  padding: 5px !important;
}
</style>
